; 
    include \masm32\include\masm32rt.inc


WinMain     proto :DWORD,:DWORD,:DWORD,:DWORD
WndProc     proto :DWORD,:DWORD,:DWORD,:DWORD

IDM_Dlg1    equ 1000
IDM_Close   equ 2000
; --------------------------------------------------------------------------
DIALOGTEST      macro
    Dialog "Test", \
           "MS Sans Serif",10, \
           WS_OVERLAPPED or WS_SYSMENU or DS_CENTER, \
           4,0,0,120,90,1024

    DlgEdit        WS_TABSTOP or WS_BORDER, 20, 10, 80, 12, 100
    DlgEdit        WS_TABSTOP or WS_BORDER, 20, 32, 80, 12, 101
    DlgButton "C", WS_TABSTOP, 30, 55, 25, 12, 102
    DlgButton "D", WS_TABSTOP, 65, 55, 25, 12, 103

    ;BS_DEFPUSHBUTTON

    CallModalDialog hInstance, 0, DlgProc, NULL
ENDM
; 
    .data
      hInstance   dd 0
      hHook       dd 0
      hwndEdit1   dd 0
      hwndEdit2   dd 0
      hwndButton1 dd 0
      hwndButton2 dd 0
      fIgnore     dd 0
;----------------------------------------------------
align 4
     _MenuName    db "DIALOG1", 0                 ; definido em rsrc.rc
align 4
_ClassName      db "Class_1", 0
align 4
_DisplayName    db "Tab_on_Enter 1", 0
_hWnd           dd 0

     .code
; 

MessageProc proc code:DWORD, wParam:WPARAM, lParam:LPARAM

    push ebx
    .IF code == MSGF_DIALOGBOX
      mov ebx, lParam
      .IF [ebx].MSG.message == WM_KEYDOWN

        .IF [ebx].MSG.wParam == VK_RETURN

          invoke GetFocus
          SWITCH eax
            CASE hwndEdit1

              invoke SetFocus, hwndEdit2

            CASE hwndEdit2

              ;----------------------------------------------
              ; Set a flag to the window procedure will know
              ; to ignore the next BN_CLICKED notification.
              ;----------------------------------------------

              mov fIgnore, 1

              ;--------------------------------------------------
              ; Make button C the default button by forcing the
              ; style to BS_DEFPUSHBUTTON. To avoid disturbing
              ; the other style bits, this code gets the current
              ; value, sets bit0, and then writes the value back.
              ; By changing the OR to an XOR this same code can
              ; be use to force the style to BS_PUSHBUTTON.
              ;--------------------------------------------------

              invoke GetWindowLong, hwndButton1, GWL_STYLE
              or eax, 1
              invoke SetWindowLong, hwndButton1, GWL_STYLE, eax

              ;---------------------------------------------
              ; Add the button to the update region so it's
              ; appearance will be updated to match the new
              ; style on the next paint.
              ;---------------------------------------------

              invoke InvalidateRgn, hwndButton1, NULL, FALSE

              invoke SetFocus, hwndButton1

            CASE hwndButton1

              ;-----------------------------------------
              ; Navigating to the next button here will
              ; disable the BN_CLICKED notification.
              ;-----------------------------------------

            CASE hwndButton2

              ;---------------------------------------
              ; Navigating to Edit1 here will disable
              ; the BN_CLICKED notification.
              ;---------------------------------------

          ENDSW

        .ENDIF
      .ENDIF
    .ENDIF
    pop ebx

    ;-----------------------------------------
    ; Return whatever CallNextHookEx returns.
    ;-----------------------------------------

    invoke CallNextHookEx, hHook, code, wParam, lParam
    ret

MessageProc endp

; 
DlgProc proc hDlg:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
    SWITCH uMsg

      CASE WM_INITDIALOG

        invoke GetDlgItem, hDlg, 100
        mov hwndEdit1, eax
        invoke GetDlgItem, hDlg, 101
        mov hwndEdit2, eax
        invoke GetDlgItem, hDlg, 102
        mov hwndButton1, eax
        invoke GetDlgItem, hDlg, 103
        mov hwndButton2, eax

        ;------------------------------------------------
        ; Install a WH_MSGFILTER hook so our MessageProc
        ; callback can intercept the dialog's messages.
        ;------------------------------------------------

        invoke GetCurrentThreadId
        invoke SetWindowsHookEx, WH_MSGFILTER, ADDR MessageProc, 0, eax

      CASE WM_COMMAND

        ;--------------------------------------------------------
        ; This switch block is actually handling the BN_CLICKED
        ; notification. For a WM_COMMAND message from a control
        ; the low-order word of wParam contains the control
        ; identifier and the high-order word the notification
        ; code. Because BN_CLICKED is actually zero, we need
        ; only compare wParam to the control identifier.
        ;--------------------------------------------------------

        SWITCH wParam

          CASE 102

            ;------------------------------------------------------
            ; If the flag is set, clear it so the next BN_CLICKED
            ; notification will be processed. If the flag is clear,
            ; process the BN_CLICKED notification.
           ;------------------------------------------------------

            .IF fIgnore
              mov fIgnore, 0
            .ELSE
            
              ;invoke MessageBox, hDlg, chr$("Button C"), chr$(" "),0
              
                ; #########################
                ; ## CLOSE Dialog WINDOW ##
                ; #########################
                invoke UnhookWindowsHookEx, hHook
                invoke EndDialog, hDlg, 0

            .ENDIF

          CASE 103

            invoke MessageBox, hDlg, chr$("Button D"), chr$(" "),0

          CASE IDCANCEL

            invoke UnhookWindowsHookEx, hHook
            invoke EndDialog, hDlg, 0

        ENDSW

      CASE WM_CLOSE

        invoke UnhookWindowsHookEx, hHook
        invoke EndDialog, hDlg, 0

    ENDSW
    xor eax, eax
    ret
DlgProc endp

; 
start:
; 

    invoke GetModuleHandle, NULL
    mov    hInstance, eax

    call     InitCommonControls

    invoke   WinMain, hInstance, NULL, NULL, SW_SHOWDEFAULT    
    invoke   ExitProcess, eax       

; #########################################################################
WinMain proc hInst:DWORD, hPrevInst:DWORD, CmdLine:DWORD, CmdShow:DWORD
        LOCAL   wc :WNDCLASSEX
        LOCAL   msg:MSG

        mov wc.cbSize,         sizeof WNDCLASSEX
        mov wc.style,          CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW
        mov wc.lpfnWndProc,    offset WndProc      
        mov wc.cbClsExtra,     NULL
        mov wc.cbWndExtra,     NULL
        push  hInst
	  pop   wc.hInstance
        
        mov wc.hbrBackground,  COLOR_BTNFACE+1     ; system color
        mov wc.lpszClassName,  offset _ClassName   ; window class name
        mov wc.lpszMenuName, offset _MenuName      ; menu name in resource file
        
        invoke LoadCursor, NULL, IDC_ARROW         ; system cursor
        mov wc.hCursor,        eax
        mov wc.hIconSm,        NULL
        mov wc.hIcon,          NULL        

        invoke RegisterClassEx, ADDR wc            ; register the window class

        ; ==================================
        ; Create the main application window
        ; ==================================
        invoke CreateWindowEx,WS_EX_OVERLAPPEDWINDOW,
                              ADDR _ClassName,
                              ADDR _DisplayName,
                              WS_OVERLAPPEDWINDOW,
                              140, 100, 500, 350,
                              NULL,NULL,
                              hInst,NULL
        mov     _hWnd, eax  

        invoke ShowWindow, _hWnd, SW_SHOWNORMAL      ; display the window
        invoke UpdateWindow, _hWnd                   ; update the display

          ; ************
          ; Message Loop
          ; ************
@@:       invoke GetMessage, ADDR msg, NULL, 0, 0         ; get each message
          cmp    eax, 0                                   ; exit if GetMessage()
          je     @F                                       
          ;
          invoke TranslateMessage, ADDR msg               ; translate it
          invoke DispatchMessage,  ADDR msg               ; send it to message proc
          jmp    @B
          ;
@@:       mov    eax, 0         
          ret
WinMain   endp
; ##############################################################################################
WndProc         proc    hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
                mov     eax, uMsg
                mov     edx, wParam
                ;
                cmp     eax, WM_COMMAND
                jne     _WM_CLOSE
                ;
                ;================== menu commands ===========================
                cmp     edx, IDM_Dlg1
                jne     _IDM_Close

                DIALOGTEST

                jmp     _eWndProc
                        
_IDM_Close:     cmp     edx, IDM_Close
                jne     _eWndProc
                ;
                invoke   SendMessage, hWin, WM_SYSCOMMAND, SC_CLOSE, NULL
                jmp     _eWndProc
                ;
                ;================= end menu commands ==========================
; 
_WM_CLOSE:      cmp     eax, WM_CLOSE
                je      @F
; 
_WM_DESTROY:    cmp     eax, WM_DESTROY
                jne     _eWndProc
                ;
@@:             invoke  PostQuitMessage, NULL
                mov     eax, 0 
                ret
; 
_eWndProc::     invoke  DefWindowProc, hWin, uMsg, wParam, lParam
                ret
WndProc         endp
; ##############################################################################################
end start
